]> git.proxmox.com Git - mirror_lxc.git/blame - src/tests/lxc-test-unpriv
spelling: timeout
[mirror_lxc.git] / src / tests / lxc-test-unpriv
CommitLineData
d08363af
SH
1#!/bin/bash
2
3# lxc: linux Container library
4
5# Authors:
6# Serge Hallyn <serge.hallyn@ubuntu.com>
7#
8# This is a test script for unprivileged containers
9
10# This library is free software; you can redistribute it and/or
11# modify it under the terms of the GNU Lesser General Public
12# License as published by the Free Software Foundation; either
13# version 2.1 of the License, or (at your option) any later version.
14
15# This library is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
18# Lesser General Public License for more details.
19
20# You should have received a copy of the GNU Lesser General Public
21# License along with this library; if not, write to the Free Software
22# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
23
061ba5d0
SG
24# This test assumes an Ubuntu host
25
d08363af 26if [ $(id -u) -ne 0 ]; then
c26adb82 27 echo "ERROR: Must run as root."
d08363af
SH
28 exit 1
29fi
90e4eead
CB
30
31# Test if we're using an overlayfs module that handles symlinks correctly. If
32# not, we skip these tests since overlay clones will not work correctly.
33if modprobe -q overlayfs; then
34 TMPDIR=$(mktemp -d)
35
36 MOUNTDIR="${TMPDIR}/ovl_symlink_test"
37
38 mkdir ${MOUNTDIR}
39
40 mount -t tmpfs none ${MOUNTDIR}
41
706f1101
PHL
42 mkdir ${MOUNTDIR}/{lowerdir,upperdir,workdir,overlayfs}
43 mount -t overlayfs -o lowerdir="${MOUNTDIR}/lowerdir",upperdir="${MOUNTDIR}/upperdir",workdir="${MOUNTDIR}/workdir" none "${MOUNTDIR}/overlayfs"
90e4eead
CB
44
45 CORRECT_LINK_TARGET="${MOUNTDIR}/overlayfs/dummy_file"
46 exec 9> "${CORRECT_LINK_TARGET}"
47
48 DETECTED_LINK_TARGET=$(readlink -q /proc/$$/fd/9)
49
50 # cleanup
51 exec 9>&-
52
53 umount "${MOUNTDIR}/overlayfs"
54 umount ${MOUNTDIR}
55
56 rmdir ${MOUNTDIR}
57
58 # This overlay module does not correctly handle symlinks, so skip the
59 # tests.
60 if [ "${DETECTED_LINK_TARGET}" != "${CORRECT_LINK_TARGET}" ]; then
61 exit 0
62 fi
63fi
64
d08363af
SH
65which newuidmap >/dev/null 2>&1 || { echo "'newuidmap' command is missing" >&2; exit 1; }
66
67DONE=0
0815a592 68KNOWN_RELEASES="precise trusty xenial yakkety zesty"
d08363af 69cleanup() {
6ebc0504 70 cd /
73d3e090 71
3ad30ff7
SH
72 run_cmd lxc-stop -n c2 -k || true
73 run_cmd lxc-stop -n c1 -k || true
d0ab6d91 74 pkill -u $(id -u $TUSER) -9 || true
73d3e090 75
061ba5d0 76 sed -i '/lxcunpriv/d' /run/lxc/nics /etc/lxc/lxc-usernet
d08363af 77 sed -i '/^lxcunpriv:/d' /etc/subuid /etc/subgid
73d3e090
SG
78
79 rm -Rf $HDIR /run/user/$(id -u $TUSER)
80
81 deluser $TUSER
82
d08363af 83 if [ $DONE -eq 0 ]; then
73d3e090
SG
84 echo "FAIL"
85 exit 1
d08363af 86 fi
73d3e090
SG
87 echo "PASS"
88}
89
90run_cmd() {
198a3f10
SG
91 sudo -i -u $TUSER \
92 env http_proxy=${http_proxy:-} https_proxy=${https_proxy:-} \
93 XDG_RUNTIME_DIR=/run/user/$(id -u $TUSER) $*
d08363af
SH
94}
95
96# create a test user
97TUSER=lxcunpriv
98HDIR=/home/$TUSER
99
fd2b7320
SG
100ARCH=i386
101if type dpkg >/dev/null 2>&1; then
102 ARCH=$(dpkg --print-architecture)
103fi
104
d08363af 105trap cleanup EXIT SIGHUP SIGINT SIGTERM
73d3e090 106set -eu
d08363af 107
438c96e9 108id $TUSER &> /dev/null && deluser -q --remove-home $TUSER
d08363af 109useradd $TUSER
73d3e090
SG
110
111mkdir -p $HDIR
9a64d3cf 112echo "$TUSER veth lxcbr0 2" >> /etc/lxc/lxc-usernet
d08363af 113sed -i '/^lxcunpriv:/d' /etc/subuid /etc/subgid
73d3e090 114
d08363af 115usermod -v 910000-919999 -w 910000-919999 $TUSER
d08363af 116
73d3e090
SG
117mkdir -p $HDIR/.config/lxc/
118cat > $HDIR/.config/lxc/default.conf << EOF
7fa3f2e9 119lxc.net.0.type = veth
120lxc.net.0.link = lxcbr0
bdcbb6b3
CB
121lxc.idmap = u 0 910000 9999
122lxc.idmap = g 0 910000 9999
d08363af 123EOF
79d88b03 124chown -R $TUSER: $HDIR
73d3e090
SG
125
126mkdir -p /run/user/$(id -u $TUSER)
79d88b03 127chown -R $TUSER: /run/user/$(id -u $TUSER)
73d3e090
SG
128
129cd $HDIR
d08363af 130
42e5c987
SG
131if which cgm >/dev/null 2>&1; then
132 cgm create all $TUSER
133 cgm chown all $TUSER $(id -u $TUSER) $(id -g $TUSER)
134 cgm movepid all $TUSER $$
135elif [ -e /sys/fs/cgroup/cgmanager/sock ]; then
ef4deb7f 136 for d in $(cut -d : -f 2 /proc/self/cgroup); do
3f458ed0
SG
137 dbus-send --print-reply --address=unix:path=/sys/fs/cgroup/cgmanager/sock \
138 --type=method_call /org/linuxcontainers/cgmanager org.linuxcontainers.cgmanager0_0.Create \
139 string:$d string:$TUSER >/dev/null
140
141 dbus-send --print-reply --address=unix:path=/sys/fs/cgroup/cgmanager/sock \
142 --type=method_call /org/linuxcontainers/cgmanager org.linuxcontainers.cgmanager0_0.Chown \
143 string:$d string:$TUSER int32:$(id -u $TUSER) int32:$(id -g $TUSER) >/dev/null
144
145 dbus-send --print-reply --address=unix:path=/sys/fs/cgroup/cgmanager/sock \
146 --type=method_call /org/linuxcontainers/cgmanager org.linuxcontainers.cgmanager0_0.MovePid \
147 string:$d string:$TUSER int32:$$ >/dev/null
148 done
149else
150 for d in /sys/fs/cgroup/*; do
8d5a91fc 151 [ "$d" = "/sys/fs/cgroup/unified" ] && continue
177f793a 152 [ -f $d/cgroup.clone_children ] && echo 1 > $d/cgroup.clone_children
3f458ed0 153 [ ! -d $d/lxctest ] && mkdir $d/lxctest
79d88b03 154 chown -R $TUSER: $d/lxctest
3f458ed0
SG
155 echo $$ > $d/lxctest/tasks
156 done
157fi
73d3e090 158
64ea46c7
PHL
159# default release is trusty, or the systems release if recognized
160release=trusty
161if [ -f /etc/lsb-release ]; then
162 . /etc/lsb-release
163 rels=$(ubuntu-distro-info --supported 2>/dev/null) ||
164 rels="$KNOWN_RELEASES"
165 for r in $rels; do
166 [ "$DISTRIB_CODENAME" = "$r" ] && release="$r"
167 done
168fi
169
57221f67
SG
170# Copy the download template cache if available
171run_cmd mkdir -p $HDIR/.cache/lxc
172[ -d /var/cache/lxc/download ] && \
173 cp -R /var/cache/lxc/download $HDIR/.cache/lxc && \
174 chown -R $TUSER: $HDIR/.cache/lxc
175
64ea46c7 176run_cmd lxc-create -t download -n c1 -- -d ubuntu -r $release -a $ARCH
73d3e090 177
a17d94a5 178# Make sure we can start it - twice
d08363af 179
a17d94a5
SH
180for count in `seq 1 2`; do
181 run_cmd lxc-start -n c1 -d
182
183 p1=$(run_cmd lxc-info -n c1 -p -H)
184 [ "$p1" != "-1" ] || { echo "Failed to start container c1 (run $count)"; false; }
185
186 run_cmd lxc-info -n c1
187 run_cmd lxc-attach -n c1 -- /bin/true
188
09ef0838 189 run_cmd lxc-stop -n c1 -k
a17d94a5 190done
73d3e090 191
d0a6bd39 192run_cmd lxc-copy -s -n c1 -N c2
3ad30ff7
SH
193run_cmd lxc-start -n c2 -d
194p1=$(run_cmd lxc-info -n c2 -p -H)
195[ "$p1" != "-1" ] || { echo "Failed to start container c2"; false; }
196
09ef0838 197run_cmd lxc-stop -n c2 -k
3ad30ff7 198
e2ef635e
SH
199if which cgm >/dev/null 2>&1; then
200 echo "Testing containers under different cgroups per subsystem"
201 run_cmd cgm create freezer x1/x2
202 cgm movepid freezer x1 $$
203 run_cmd lxc-start -n c1 -d
204 p1=$(run_cmd lxc-info -n c1 -p -H)
205 [ "$p1" != "-1" ] || { echo "Failed to start container c1"; false; }
206 run_cmd lxc-info -n c1
207 run_cmd lxc-attach -n c1 -- /bin/true
208 run_cmd lxc-cgroup -n c1 freezer.state
209
210 echo "Testing lxc-attach and lxc-cgroup from different cgroup"
211 cgm movepid freezer x2 $$
212 run_cmd lxc-attach -n c1 -- /bin/true
213 run_cmd lxc-cgroup -n c1 freezer.state
214 run_cmd lxc-cgroup -n c1 memory.limit_in_bytes
215fi
216
d08363af 217DONE=1